/*
 * Aipo is a groupware program developed by Aimluck,Inc.
 * Copyright (C) 2004-2008 Aimluck,Inc.
 * http://aipostyle.com/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.aimluck.eip.office;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.cayenne.ObjectId;
import org.apache.cayenne.access.DataContext;
import org.apache.cayenne.exp.Expression;
import org.apache.cayenne.exp.ExpressionFactory;
import org.apache.cayenne.query.SelectQuery;
import org.apache.jetspeed.services.logging.JetspeedLogFactoryService;
import org.apache.jetspeed.services.logging.JetspeedLogger;
import org.apache.turbine.util.RunData;
import org.apache.velocity.context.Context;

import com.aimluck.eip.cayenne.om.portlet.ImwTOffice;
import com.aimluck.eip.common.ALAbstractCheckList;
import com.aimluck.eip.orm.DatabaseOrmService;
import com.aimluck.eip.services.datasync.ALDataSyncFactoryService;
import com.aimluck.eip.util.ALEipUtils;

/**
 * 勤務先を複数有効化するためのクラス． <BR>
 *
 */
public class OfficeMultiEnable extends ALAbstractCheckList {

  /** logger */
  private static final JetspeedLogger logger = JetspeedLogFactoryService
      .getLogger(OfficeMultiDelete.class.getName());

  /**
   *
   * @param rundata
   * @param context
   * @param values
   * @param msgList
   * @return
   * @see com.aimluck.eip.common.ALAbstractCheckList#action(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context, java.util.ArrayList,
   *      java.util.ArrayList)
   */
  protected boolean action(RunData rundata, Context context, ArrayList values,
      ArrayList msgList) {

    try {
      // WebAPIのDBへ接続できるか確認
      if (!ALDataSyncFactoryService.getInstance().getDataSyncHandler()
          .checkConnect()) {
        msgList.add("コントロールパネルWebAPIのデータベースの接続に失敗したため、処理は実行されませんでした。");
        return false;
      }
      
      DataContext dataContext = DatabaseOrmService.getInstance()
          .getDataContext();
      Expression exp = ExpressionFactory.inDbExp(ImwTOffice.OFFICE_ID_PK_COLUMN,
          values);
      SelectQuery query = new SelectQuery(ImwTOffice.class, exp);
      List ulist = dataContext.performQuery(query);
      if (ulist == null || ulist.size() == 0)
          return false;

      int size = ulist.size();
      Integer[] office_id_list = new Integer[size];

      for (int i = 0; i < size; i++) {
          ImwTOffice record = (ImwTOffice) ulist.get(i);
          Integer office_id = record.getOfficeId();
          office_id_list[i] = office_id;
          if (office_id == null)
            return false;

          // 勤務先を有効化
          ObjectId oid_office = new ObjectId("ImwTOffice",
              ImwTOffice.OFFICE_ID_COLUMN, office_id);
          ImwTOffice office = (ImwTOffice) dataContext.refetchObject(oid_office);
        office.setDisabled("F");
        
        office.setUpdateDate(new Date());
        
        office.setUpdateUserId(ALEipUtils.getUserId(rundata));
      }

      dataContext.commitChanges();

      return true;
    } catch (Exception e) {
      logger.error("Exception", e);
      return false;
    }
  }
}
